unit Mathprg;

interface

type
    Tfloat = extended;

type
    TVarray = array of Tfloat;
    TV2array = array of array of Tfloat;
    TViarray = array of integer;

type
   TFX   = function (x:Tfloat):Tfloat;
   TFXY  = function (x,y:Tfloat):Tfloat;
   TPYDY = procedure (t:Tfloat; Y, YP:TVarray);

type
    TComplex = record
                     Re : Tfloat;
                     Im : Tfloat;
               end;
Var
{    RKF45}
   YP, F1, F2, F3, F4, F5 : TVarray;
{    RKF45}
   H, Savre, Savae, eps, u26    :Tfloat;
   nfe, kop, init, jflag, kflag : integer;

Var
{    Decomp  Solve}
   Ipvt :TViarray;

{*******************************************************************}
{ }
{*******************************************************************}
{Sign   x 
      -1,  x<0;
      0,  x=0;
      1,  x>0;
      }
    function Sign(x:Tfloat):integer;
{ISign   x 
      -1,  x<0;
      0,  x=0;
      1,  x>0;
      }
    function ISign(x:integer):integer;

{*******************************************************************}
{ }
{*******************************************************************}
    function CSop(x:TComplex):TComplex;                {. }
    function CAdd(x,y:TComplex):TComplex;              {}
    function CSub(x,y:TComplex):TComplex;              {}
    function CMul(x,y:TComplex):TComplex;              {}
    function CDiv(x,y:TComplex):TComplex;              {}
    function CAlgeb(a,b:Tfloat):TComplex;              { c = a + ib  }
    function CTrign(Modul,Argument:Tfloat):TComplex;   { c = Mod*(cos(Arg) +
                                                                 isin(Arg)) }
    function CRe(x:TComplex):Tfloat;                   { Re(c) }
    function CIm(x:TComplex):Tfloat;                   { Im(c) }
    function CAbs(x:TComplex):Tfloat;                  { Abs(c) }
    function CArg(x:TComplex):Tfloat;                  { Argument(c) }

{*******************************************************************}
{    }
{*******************************************************************}
{Tsheb -   ( )
 n (n>=0)-  ;
 x       - }
    function Tsheb(n:integer; x:Tfloat):Tfloat;

{TshebN -    
 n (n>=0)-  ;
 x       - ;
 T       -    N   
            T[i]  0<= i <= n }
    procedure TshebN(n:integer; x:Tfloat;T:TVarray);
{Erf -  }
    function Erf(x:Tfloat):Tfloat;
{Erfc = 1- Erf(x) }    
    function Erfc(x:Tfloat):Tfloat;

{*******************************************************************}
{     }
{*******************************************************************}

{Decomp  Solve -      .}

{Decomp -   A    , 
   Cond ,  , .
  :
 N       -  
 A       -  (     U 
                
 CalcDet - True,   .   ,
               0
 Cond    -  .    Cond=1e32
 Determ  -  
 IsidnD  - (-1)**( )
 }
    function Decomp(N:integer; A:TV2array;  CalcDet:boolean;
                 var Cond:Tfloat;
                 var Determ:Tfloat; var ISignD:integer) :boolean;
{Solve -   (     Decomp)
 N       -  
 A       -  Decomp 
 B       -    (    )
 }
    procedure Solve(N:integer; A:TV2array; B:TVarray);

{SVD -    
 M     -   A ( U)
 N     -   A ( U)   V
 A     -   
 matu  - True,     U  
 matv  - True,     V  
 
 U     -    
 V     -  
 W     -  N    A
 ierr  - 0,   , K,  -  
             30 
}
    procedure SVD(M, N :integer; A:TV2array; matu, matv :boolean;
           U, V :TV2array;W :TVarray; var ierr :integer);
{Transpon -    A
 M     -   A   C;
 N     -   A   C;
 A     -   M*N;
 C     -   N*M;
 }
    procedure Transpon(M, N :integer; A, C: TV2array);

{MatriMul -  
 M     -   A,C   B;
 N     -   A,C   B;
 A     -   M*N;
 B     -   N*M;
 C     -   M*N -  A*B;
}
    procedure MatriMul(M, N :integer; A, B, C: TV2array);

{    }
{LAI -  SVD    A[M,N]*C[N]=B[M]
 M -    A;
 N -    A;
 A -    M*N;
 B -     M;
 C -    N;
 relerr -     ;
  - TRUE,  SVD  IERR=0     C;
 }
    function LAI(M,N:integer; A:TV2array; B,C:TVarray; relerr:Tfloat):boolean;


{*******************************************************************}
{  }
{*******************************************************************}
{Zeroin -     F(x)=0  
ax<= x <=bx    Tol.  F(x)   
  .  [1].
 :
ax, bx  -       ;
F       -    x ;
Tol     -    ;
  ( TRUE):
root    -   .
}
    function Zeroin(ax, bx :Tfloat; F :TFX; Tol :Tfloat;
            var root :Tfloat):boolean;

{*******************************************************************}
{,    }
{*******************************************************************}
{FMin -    F(x)  
ax<= x <=bx    Tol.  [1].
 :
ax, bx  -       ;
F       -    x ;
Tol     -   ;
  :    -    .
}
    function FMin(ax,bx:Tfloat; F:TFX; tol:Tfloat):Tfloat;


{*******************************************************************}
{ }
{*******************************************************************}
{Quanc8 -     
 [1].
    :
Fun       -    f(x);
a         -   ;
b         -   ;
abserr    -    (>0);
relerr    -    (>0);
    :
errest    -    ;
flag      -  .  =0,    
               .  flag=xxx.yyy, 
            xxx=  ,     ,
             0.yyy=   (a,b)   
              ,     Nofun;
Nofun     -   ,  .
}
    function Quanc8(Fun :TFX; a,b,abserr,relerr :Tfloat;
            var errest,flag :Tfloat; var Nofun :integer):Tfloat;

   {QG8 -     8-    [a,b]
         (: [2])
     Fun -    f(x);
     a   -   ;
     b   -   }
    function QG8(Fun :TFX; a,b :Tfloat):Tfloat;

   {QG16 -     16-    [a,b]
         (: [2])
     Fun -    f(x);
     a   -   ;
     b   -   }
    function QG16(Fun :TFX; a,b :Tfloat):Tfloat;

   {QG32 -     32-    [a,b]
         (: [2])
     Fun -    f(x);
     a   -   ;
     b   -   }
    function QG32(Fun :TFX; a,b :Tfloat):Tfloat;

   {QGL8 -     8-    
   [0,infinity]    exp(-x)   
     (: [2])
     Fun -    f(x) (  );
        - 0;
        - }
    function QGL8(Fun :TFX):Tfloat;

  {QGH8 -     8-    
  [-infinity,infinity]    exp(-x^2)  
     (: [2])
     Fun -    f(x) (  );
        -  ;
        - }
   function QGH8(Fun :TFX):Tfloat;

   {DQG8 -     8-   
          (: [2])
     Fun -    f(x,y);
     a   -     X;
     b   -     Y;
     Fc  -     Y (  X)
     Fd  -     Y (  X)
     }
    function DQG8(Fun:TFXY; a,b:Tfloat; Fc,Fd:TFX):Tfloat;


{*******************************************************************}
{     }
{*******************************************************************}
{  RKF45 -     
              :
           dY[i]/dt = F(t,Y[1],Y[2],...Y[Neqn]),
            Y[i] -    t.
            [1].
   F      -    .
              - (t:Tfloat; Y, YP:TVarray),
            
            t  -  ;
            Y  -      t;
            YP -       t;
   Neqn   -   ;
  :
   Y      -      t;
   t      -   ;
   tout   -    ( );
   abserr -   ;
   relerr -   ;
   Iflag  -   ;
  :
   Y      -      tout;

         Iflag   
   Iflag:=1.  (  )     2 
      .   Iflag:
   Iflag=-1 -   (  );
   Iflag=-2 -      ;
   Iflag=3  -     ;
   Iflag=4  -    - ,  
              3000   ( 500 );
   Iflag=5  -    - ,   
                     
             .   abserr>0.   
                 .
   Iflag=6  -    - ,   
             .    .
   Iflag=7  -    (  > tout-t).
                .
   Iflag=8  -   :
             - Neqn<=0;
             - t=tout  Iflag<>1  -1;
             - relerr  abserr <0;
             - Iflag=0  Iflag<-2  Iflag>8.
}
   procedure RKF45(F:TPYDY; Neqn :integer; Y:TVarray;
             var t:Tfloat; tout:Tfloat; var relerr:Tfloat;
             abserr:Tfloat; var Iflag :integer);


{*******************************************************************}
{  }
{*******************************************************************}
{ Spline  Seval -     
  .  [1].
  Spline -   B[i], C[i], D[i], i=0,1...N-1 
            .
  N     -      (N>=2);
  X     -      ;
  Y     -  ;
  B,C,D -   .
}
   procedure Spline(N:integer; X,Y,B,C,D:TVarray);
{  Seval -   .   
            Spline.
  N     -      (N>=2);
  U     - ,      ;
  X, Y, B,C,D - ,    Spline.
}
   function  Seval(N:integer;U:Tfloat; X,Y,B,C,D:TVarray):Tfloat;

{------------------         ------------------------------
 1. ., ., .,   
    , ., "", 1980.
 2. .., ..,   
    , ., "", 1984.
}
implementation
uses
    Math;

{ }
    function Sign(x:Tfloat):integer;
    Begin
         if x<0 then
                    Result := -1
                else
                if x=0 then
                           Result := 0
                       else
                           Result := 1;
    End;

    function ISign(x:integer):integer;
    Begin
         if x<0 then
                    Result := -1
                else
                if x=0 then
                           Result := 0
                       else
                           Result := 1;
    End;

    function Erf(x:Tfloat):Tfloat;
var
   s1,s2,s3,s4,s5,s6,s7,s8,s9,s10,s11,s12,s13,s14,s15,s16,s17,s18,s19,s20,s21,
   s22,s23,y :Tfloat;
Begin
     if x<=2.86 then
     begin
          y := 0.69930069930069930070*x-1.0;
      s1 := 0.9568572531449689;
      s4 := 0.2087864503387514;
      s7 := -0.4269474122977127;
      s10 := 0.4397273715058243;
      s13 := -0.158577663193599;
      s16 := -0.1400493652118421;
      s19 := 0.1819357725644533;
      s22 := -0.3810990634731706E-1;
      s23 := (-0.6024021912404807E-1+(0.4252773403103953E-1+(
0.4506602728517494E-2+(-0.1590618525488693E-1+(0.4024797297904547E-2+(
0.3320877488047494E-2+(-0.2055438565933685E-2+(-0.2803512322638458E-3+(
0.5620308013343762E-3+(-0.7198093539540885E-4+(-0.1038333751632669E-3+(
0.3698391937060801E-4+(0.125532757323007E-4+(-0.9287712883110977E-5+(
-0.4971658980803684E-6+(0.1665314945996346E-5+(-0.2012607933061778E-6+(
-0.2285870711003871E-6+(0.6502793268961277E-7+(0.2372766349197143E-7+(
-0.1177621321459287E-7+(-0.1691925271463316E-8+(0.1424274587822993E-8+(
0.614198179515066E-10-0.9227900795494829E-10*y)*y)*y)*y)*y)*y)*y)*y)*y)*y)*y)*y
)*y)*y)*y)*y)*y)*y)*y)*y)*y)*y)*y)*y)*y;
      s21 := s22+s23;
      s22 := y;
      s20 := s21*s22;
      s18 := s19+s20;
      s19 := y;
      s17 := s18*s19;
      s15 := s16+s17;
      s16 := y;
      s14 := s15*s16;
      s12 := s13+s14;
      s13 := y;
      s11 := s12*s13;
      s9 := s10+s11;
      s10 := y;
      s8 := s9*s10;
      s6 := s7+s8;
      s7 := y;
      s5 := s6*s7;
      s3 := s4+s5;
      s4 := y;
      s2 := s3*s4;
      Result := s1+s2;
     end
               else
     if x<=4.29 then
     begin
          y := 1.3986013986013986014*x-5.0000000000000000000;
          Result :=
      0.9999995714399782+(0.2270942762864545E-5+(-0.580481356972621E-5+(
0.9504898485935404E-5+(-0.1115866571548697E-4+(0.9951435242841328E-5+(
-0.6957813768107861E-5+(0.3870149417941707E-5+(-0.1710930350229841E-5+(
0.5871443307677308E-6+(-0.1446658903524011E-6+(0.1811581103039407E-7+(
0.3487822826107841E-8+(-0.2677450744499432E-8+(0.7426463445142545E-9+(
-0.8391012290254422E-10+(-0.1756863998661479E-10+(0.1023022702640172E-10+(
-0.1905859362897773E-11+(-0.1029271130151545E-12+0.9445701836918432E-13*y)*y)*y
)*y)*y)*y)*y)*y)*y)*y)*y)*y)*y)*y)*y)*y)*y)*y)*y)*y;               
     end
                               else         
     if x<=6.0 then
     begin
          y := 0.90497737556561085972*x-4.8823529411764705882;
          Result :=
      0.9999999999999765+(0.2852536562091598E-12+(-0.1700535662572328E-11+
(0.6642359320488564E-11+(-0.1910687292950358E-10+(0.4312907901098305E-10+(
-0.7948491712503441E-10+(0.1228446904635872E-9+(-0.162271382105808E-9+(
0.1858170909074475E-9+(-0.1863961139050021E-9+(0.1648708536868154E-9+(
-0.1291200273692166E-9+(0.9011991876959465E-10+(-0.5634765918678299E-10+(
0.3103167479189546E-10+(-0.1463252357302702E-10+(0.6215350927934987E-11+(
-0.2594360975708481E-11+(0.7916579827589455E-12+(-0.2645917173237797E-13
-0.4354425654001674E-13*y)*y)*y)*y)*y)*y)*y)*y)*y)*y)*y)*y)*y)*y)*y)*y)*y)*y)*y
)*y)*y;          
     end
               else
          Result := 1;                           
End;

    function Erfc(x:Tfloat):Tfloat;
    Begin
         Result := 1 - Erf(x);
    End;

{ }
    function CSop(x:TComplex):TComplex;
    begin
         Result.Re := x.Re;
         Result.Im := -x.Im;
    end;

    function CAbs(x:TComplex):Tfloat;
    begin
         Result := Sqrt(Sqr(x.Re)+Sqr(x.Im));
    end;

    function CAdd(x,y:TComplex):TComplex;
    begin
         Result.Re := x.Re + y.Re;
         Result.Im := x.Im + y.Im;
    end;

    function CSub(x,y:TComplex):TComplex;
    begin
         Result.Re := x.Re - y.Re;
         Result.Im := x.Im - y.Im;
    end;

    function CMul(x,y:TComplex):TComplex;
    begin
         Result.Re := x.Re*y.Re - x.Im*y.Im;
         Result.Im := x.Re*y.Im + x.Im*y.Re;
    end;

    function CDiv(x,y:TComplex):TComplex;
    var cab :Tfloat;
    begin
         cab := Sqr(y.Re)+Sqr(y.Im);
         Result.Re := (x.Re*y.Re + x.Im*y.Im)/cab;
         Result.Im := (-x.Re*y.Im + x.Im*y.Re)/cab;
    end;

    function CAlgeb(a,b:Tfloat):TComplex;
    begin
         Result.Re := a;
         Result.Im := b;
    end;

    function CTrign(Modul,Argument:Tfloat):TComplex;
    begin
         Result.Re := Modul*Cos(Argument);
         Result.Im := Modul*Sin(Argument);
    end;

    function CRe(x:TComplex):Tfloat;
    begin
         Result := x.Re;
    end;

    function CIm(x:TComplex):Tfloat;
    begin
         Result := x.Im;
    end;

    function CArg(x:TComplex):Tfloat;
    begin
         Result := ArcTan2(x.Im,x.Re);
    end;

{    }
{Tsheb -  }
    function Tsheb(n:integer; x:Tfloat):Tfloat;
    Begin
         if n<0 then
                    begin
                         Result := 0;
                         Exit;
                    end
                else
         case n of
         0: Result := 1;
         1: Result := x;
         else
             Result := 2*x*Tsheb(n-1,x)-Tsheb(n-2,x);
         end;
    end;

    procedure TshebN(n:integer; x:Tfloat;T:TVarray);
    var i :integer;
    Begin
         if n<0 then Exit;
         case n of
         0: T[0] := 1;
         1: T[1] := x;
         else
             T[0] := 1;
             T[1] := x;
             for i := 2 to n do
                 T[i] := 2*x*T[i-1]-T[i-2];
         end;
    end;


{     }

    function Decomp(N:integer; A:TV2array; CalcDet:boolean;
                 var Cond:Tfloat;
                 var Determ:Tfloat; var ISignD:integer) :boolean;
    var
       Work : TVArray;
       ek, t, anorm, ynorm, znorm, s : Tfloat;
       nm1, i, j, k, kp1, kb, km1, m : integer;
    Begin
         Result := True;
         SetLength(Work, N);
         SetLength(Ipvt, N);
         Ipvt[N-1] := 1;
         if N=1 then           { 1*1}
         begin
              Cond := 1;
              if  CalcDet then Determ := A[0,0];
              ISignD := 1;
              if A[0,0]<>0 then
                               Exit
                           else
                               begin
                                    Cond := 1.0e32;
                                    if  CalcDet then
                                                    Determ := 0;
                                    Result := False;
                                    ISignD := 0;
                                    Exit;
                               end
         end
                else
         begin              { N>1}
              nm1 := N-2;
              anorm := 0;
              for j := 0 to N-1 do
              begin
                   t := 0;
                   for i := 0 to N-1 do t := t+Abs(A[i,j]);
                   if t>anorm then anorm := t;
              end;
{  }
              for k:=0 to nm1 do
              begin
                   kp1 := k+1;
                   m:=k;
                   for i:=kp1 to N-1 do
                       if Abs(A[i,k])>Abs(A[m,k]) then
                                                      m:=i;
                   Ipvt[k] := m;
                   if m<>k then
                               Ipvt[N-1] := - Ipvt[N-1];
                   t := A[m,k];
                   A[m,k] := A[k,k];
                   A[k,k] := t;
                   if t<>0 then
                   begin
                        for i:=kp1 to N-1 do
                                            A[i,k] := -A[i,k]/t;
                        for j:=kp1 to N-1 do
                        begin
                             t := A[m,j];
                             A[m,j] := A[k,j];
                             A[k,j] := t;
                             if t<>0 then
                                        for i:=kp1 to N-1 do
                                            A[i,j] := A[i,j]+A[i,k]*t;
                        end
                   end;
{Cond=...}    end;
              for k := 0 to N-1 do
              begin
                        t := 0;
                        if k>0 then
                        begin
                             km1 :=k-1;
                             for i := 0 to km1 do
                                 t := t+A[i,k]*Work[i];
                        end;
                        ek := 1;
                        if t<0 then ek := -1;
                        if A[k,k]=0 then
                        begin
                             Cond := 1.0e32;
                             if  CalcDet then
                                             Determ := 0;
                             ISignD := 0;
                             Result := False;
                             Exit;
                        end;
                        Work[k] := - (ek+t)/A[k,k];
              end;
              for kb:=0 to nm1 do
              begin
                        k := N-2-kb;
                        t := 0;
                        kp1 := k+1;
                        for i := kp1 to N-1 do
                            t := t+A[i,k]*Work[k];
                        Work[k] := t;
                        m := Ipvt[k];
                        if m<>k then
                        begin
                             t := Work[m];
                             Work[m] := Work[k];
                             Work[k] := t;
                        end;
              end;
              ynorm := 0;
              for i := 0 to N-1 do
                   ynorm := ynorm + Abs(Work[i]);
              Solve(N, A, Work);
              znorm := 0;
                   for i := 0 to N-1 do
                       znorm := znorm + Abs(Work[i]);
{ }
                   Cond := anorm*znorm/ynorm;
                   if Cond<1 then Cond := 1;
                   if  CalcDet then
                   begin
                        S := 0;
                        for i:=0 to N-1 do
                                S := S + Ln(A[i,i]);
                        Determ := Ipvt[N-1]*exp(S);
                        ISignD := Ipvt[N-1];
                   end;
         end;
    End;

    procedure Solve(N:integer; A:TV2array; B:TVarray);
    var
       kb, km1, nm1, kp1, i, k, m : integer;
       t                          : Tfloat;
    Begin
         if N>1 then
         begin
              nm1 := N-2;
              for k := 0 to nm1 do
              begin
                   kp1 := k+1;
                   m := Ipvt[k];
                   t := B[m];
                   B[m] := B[k];
                   B[k] := t;
                   for i:=kp1 to N-1 do
                       B[i] := B[i] + A[i,k]*t;
              end;
              for kb:=0 to nm1 do
              begin
                   km1 := N-kb-2;
                   k := km1+1;
                   B[k] := B[k]/A[k,k];
                   t := -B[k];
                   for i:=0 to km1 do
                       B[i] := B[i]+A[i,k]*t;
              end;
         end;
         B[0] := B[0]/A[0,0];
    End;


 procedure SVD(M, N :integer; A:TV2array; matu, matv :boolean;
           U, V :TV2array;W :TVarray; var ierr :integer);
 var
    RV1 :TVarray;
    i,j,k,l,ii,i1,kk,k1,ll,its,mn :integer;
    c,f,g,h,s,x,y,z,scale,anorm      :Tfloat;
 label
      l490, l520, l565;
 Begin
      ierr := 0;
      SetLength(RV1, N);
      for i:=0 to M-1 do
          for j:=0 to N-1 do
                            U[i,j] := A[i,j];
      g :=0;
      scale := 0;
      anorm := 0;
      for i := 0 to N-1 do
      begin
           l       := i+1;
           RV1[i]  := scale*g;
           g       := 0;
           s       := 0;
           scale   := 0;
           if i<=M-1 then
           begin
                for k := i to M-1 do
                    scale   := scale+Abs(U[k,i]);
                if scale<>0 then
                begin
                     for k := i to M-1 do
                     begin
                          U[k,i]  := U[k,i]/scale;
                          s       := s+Sqr(U[k,i]);
                     end;
                     f  := U[i,i];
                     if f>0 then
                                g := -Sqrt(s)
                            else
                                g := Sqrt(s);
                     h      := f*g-s;
                     U[i,i] := f-g;
                     if i<>N-1 then
                     begin
                          for j := l to N-1 do
                          begin
                               s := 0;
                               for k := i to M-1 do
                                    s := s+U[k,i]*U[k,j];
                               f := s/h;
                               for k := i to M-1 do
                                   U[k,j] := U[k,j]+f*U[k,i];
                          end;
                     end;
                     for k := i to M-1 do
                         U[k,i] := scale*U[k,i];
                end;
           end;
           W[i]   := scale*g;
           g       := 0;
           s       := 0;
           scale   := 0;
           if (i<=M-1) and (i<>N-1) then
           begin
                for k := l to N-1 do
                    scale := scale + Abs(U[i,k]);
                if scale<>0 then
                begin
                     for k := l to N-1 do
                     begin
                          U[i,k] := U[i,k]/scale;
                          s      := s+Sqr(U[i,k]);
                     end;
                     f := U[i,l];
                     if f>0 then
                                g := -Sqrt(s)
                             else
                                g := Sqrt(s);
                     h := f*g-s;
                     U[i,l] := f-g;
                     for k := l to N-1 do
                         RV1[k] := U[i,k]/h;
                     if i<>M-1 then
                          for j := l to M-1 do
                          begin
                               s := 0;
                               for k := l to N-1 do
                                   s := s+U[j,k]*U[i,k];
                               for k := l to N-1 do
                                   U[j,k] := U[j,k]+s*RV1[k];
                          end;
                          for k := l to N-1 do
                           U[i,k] := scale*U[i,k];
                end;
           end;
           anorm := Max(anorm, Abs(W[i])+Abs(RV1[i]));
      end;

      if matv then
      begin
           for i := N-1 downto 0 do
           begin
                if i<>N-1 then
                begin
                     if g<>0 then
                     begin
                          for j := l to N-1 do
                              V[j,i] := (U[i,j]/U[i,l])/g;
                          for j := l to N-1 do
                          begin
                               s := 0;
                               for k := l to N-1 do
                                   s := s+U[i,k]*V[k,j];
                               for k := l to N-1 do
                                   V[k,j] := V[k,j]+s*V[k,i];
                          end;
                     end;
                     for j := l to N-1 do
                     begin
                           V[i,j] :=0;
                           V[j,i] :=0;
                     end;
                end;
                V[i,i] := 1;
                g      := RV1[i];
                l      := i;
           end;
      end;
      if matu then
      begin
           mn := N;
           if M<N then mn := M;
           for i := mn-1 downto 0 do
           begin
                l   := i+1;
                g   := W[i];
                if i<>N-1 then
                   for j := l to N-1 do
                       U[i,j] := 0;
                if g<>0 then
                begin
                     if i<>mn-1 then
                     begin
                          for j := l to N-1 do
                          begin
                               s   := 0;
                               for k := l to M-1 do
                                   s := s+U[k,i]*U[k,j];
                               f   := (s/U[i,i])/g;
                               for k := i to M-1 do
                                   U[k,j] := U[k,j]+f*U[k,i];
                          end;
                     end;
                     for j := i to M-1 do
                         U[j,i] := U[j,i]/g;
                goto l490;
                end;
                for j := i to M-1 do
                    U[j,i] := 0;
l490:           U[i,i] := U[i,i]+1;
           end;
      end;
      for k := N-1 downto 0 do
      begin
           its := 0;
l520:      for l := k downto 0 do
           begin
                if (Abs(RV1[l])+anorm)=anorm then goto l565;
                if (Abs(W[l-1])+anorm)=anorm then Break;
           end;
           c   := 0;
           s   := 1;
           for i := l to k do
           begin
                f      := s*RV1[i];
                RV1[i] := c*RV1[i];
                if (Abs(f)+anorm)=anorm then goto l565;
                g  := W[i];
                h  := Sqrt(f*f+g*g);
                W[i] := h;
                c    := g/h;
                s    := -f/h;
                if not matu then Continue;
                for j := 0 to M-1 do
                begin
                     y   := U[j,l-1];
                     z   := U[j,i];
                     U[j,l-1] := y*c+z*s;
                     U[j,i]    := -y*s+z*c;
                end;
           end;
l565:      z := W[k];
           if l<>k then
           begin
                if its=30 then
                begin
                     ierr := k;
                     Exit;
                end;
                its  := its+1;
                x    := W[l];
                y    := W[k-1];
                g    := RV1[k-1];
                h    := RV1[k];
                f    := ((y-z)*(y+z)+(g-h)*(g+h))/(2*h*y);
                g    := Sqrt(f*f+1);
                f    := ((x-z)*(x+z)+h*(y/(f+g*Abs(f)/f)-h))/x;
                c    := 1;
                s    := 1;
                for i1 := l to k-1 do
                begin
                     i   := i1+1;
                     g   := RV1[i];
                     y   := W[i];
                     h   := s*g;
                     g   := c*g;
                     z   := Sqrt(f*f+h*h);
                     RV1[i1] := z;
                     c       := f/z;
                     s       := h/z;
                     f       := x*c+g*s;
                     g       := -x*s+g*c;
                     h       := y*s;
                     y       := y*c;
                     if matv then
                        for j := 0 to N-1 do
                        begin
                             x   := V[j,i1];
                             z   := V[j,i];
                             V[j,i1] := x*c+z*s;
                             V[j,i]  := -x*s+z*c;
                        end;
                        z := Sqrt(f*f+h*h);
                        W[i1] := z;
                        if z<>0 then
                        begin
                             c := f/z;
                             s := h/z;
                        end;
                        f := c*g+s*y;
                        x := -s*g+c*y;
                        if matu then
                        for j := 0 to M-1 do
                        begin
                             y := U[j,i1];
                             z := U[j,i];
                             U[j,i1] := y*c+z*s;
                             U[j,i]  := -y*s+z*c;
                        end;
                end;
                RV1[l] := 0;
                RV1[k]  := f;
                W[k]    := x;
                goto l520;
           end;
           if z>=0 then Continue;
           W[k] := -z;
           if not matv then Continue;
           for j := 0 to N-1 do
                V[j,k] := -V[j,k];
      end;
 End;

    procedure Transpon(M, N :integer; A, C: TV2array);
    var
       i, j :integer;
    begin
         for j := 0 to M-1 do
             for i := 0 to N-1 do
                 C[i,j] := A[j,i];
    end;

    procedure MatriMul(M, N :integer; A, B, C: TV2array);
    var
       j, k, l :integer;
       s       :Tfloat;
    begin
         for k := 0 to M-1 do
            for j := 0 to N-1 do
            begin
                 s := 0;
                 for l := 0 to N-1 do
                         s := s + A[k,l]*B[l,j];
                 C[k,j] := s;
            end;
    end;

{    }
    function LAI(M,N:integer; A:TV2array; B,C:TVarray; relerr:Tfloat):boolean;
    var
       U,V :TV2array;
       W   :TVarray;
       i, j, ierr :integer;
       tau, sigma1, s :Tfloat;
    Begin
         SetLength(U,M,N);
         SetLength(V,M,N);
         SetLength(W,M);
         SVD(M,N,A,true,true,U,V,W,ierr);
         if ierr>0 then
                       Result := false
                   else
         begin
              sigma1 := 0;
              for j := 0 to N-1 do
              begin
                   if W[j]>sigma1 then sigma1:=W[j];
                   C[j] := 0;
              end;
              tau := sigma1*relerr;
              for j := 0 to N-1 do
              begin
                   if W[j]<=tau then Continue;
                   s := 0;
                   for i := 0 to M-1 do
                        s := s+U[i,j]*B[i];
                   s := s/W[j];
                   for i := 0 to N-1 do
                       C[i] := C[i]+s*V[i,j];
              end;
              U := nil;
              V := nil;
              W := nil;
              Result := true;
         end;
    End;


{  }
   function Zeroin(ax, bx :Tfloat; F :TFX; Tol :Tfloat;
            var root :Tfloat):boolean;
    Label
         l20, l30, l40, l50, l60, l70, l80;
    var
       a, b, c, d, e, eps, fa, fb, fc, tol1, xm, p, q, r, s :Tfloat;
    Begin
         eps := 1;
         tol1:= 1+eps;
         while tol1>1 do
                        begin
                             eps  := 0.5*eps;
                             tol1 := 1+eps;
                        end;
         a  := ax;
         b  := bx;
         fa := F(a);
         fb := F(b);
         if fa*fb>0 then
                        begin
                             root := 0;
                             Result := False;
                        end
                    else
                             Result := True;
    l20: c  := a;
         fc := fa;
         d  := b-a;
         e := b;
    l30: if Abs(fc)<Abs(fb) then
         begin
              a  := b;
              b  := c;
              c  := a;
              fa := fb;
              fb := fc;
              fc := fa;
         end;
    l40: tol1 := 2*eps*Abs(b)+0.5*tol;
         xm := 0.5*(c-b);
         if (Abs(xm)<=tol1) or (fb=0) then
                                          begin
                                               Root := b;
                                               Exit;
                                          end;
         if (Abs(e)<tol1) or (Abs(fa)<=Abs(fb)) then goto l70;
         if a<>c then goto l50;
         s := fb/fa;
         p := 2*xm*s;
         q := 1-s;
         goto l60;
    l50: q := fa/fc;
         r := fb/fc;
         s := fb/fa;
         p := s*(2*xm*q*(q-r)-(b-a)*(r-1));
         q := (q-1)*(r-1)*(s-1);
    l60: if p>0 then q := -q;
         p := Abs(p);
         if ((2*p)>=(3*xm*q-Abs(tol1*q)))
            or (p>=Abs(0.5*e*q)) then goto l70;
         e := d;
         d := p/q;
         goto l80;
    l70: d := xm;
         e := d;
    l80: a  := b;
         fa := fb;
         if Abs(d)>tol1 then
                            b := b+d
                        else
                            b := b+Abs(tol1)*xm/Abs(xm);
         fb := F(b);
         if (fb*(fc/Abs(fc)))>0 then
                                    goto l20
                                else
                                    goto l30;
    End;


{,    }
    function FMin(ax,bx:Tfloat; F:TFX; tol:Tfloat):Tfloat;
    var
       a, b, c, d, e, eps, xm, p, q, r, tol1, tol2, u, v, w :Tfloat;
       fu, fv, fw, fx,       x                              :Tfloat;
    label
         l30, l40, l50;
    Begin
         c := 0.5*(3-Sqrt(5));
         eps := 1;
         repeat
               eps := eps/2;
               tol1:=1+eps;
         until tol1=1;
         eps := Sqrt(eps);
         a   := ax;
         b   := bx;
         v   := a+c*(b-a);
         w   := v;
         x   := v;
         e   := 0;
         fx  := F(x);
         fv  := fx;
         fw  := fx;
{20}     repeat
               xm    := 0.5*(a+b);
               tol1  := eps*Abs(x)+tol/3;
               tol2  := 2*tol1;
               if Abs(x-xm)<=(tol2-0.5*(b-a)) then Break; {goto 90}
               if Abs(e)<=tol1 then goto l40;
               r := (x-w)*(fx-fv);
               q := (x-v)*(fx-fw);
               p := (x-v)*q-(x-w)*r;
               q := 2*(q-r);
               if q>0 then p := -p;
               q := Abs(q);
               r := e;
               e := d;
l30:           if (Abs(p)>=Abs(0.5*q*r)) or
                  (p<=q*(a-x)) or
                  (p>=q*(b-x))             then goto l40;
               d := p/q;
               u := x+d;
               if ((u-a)<tol2) or ((b-u)<tol2) then
                             if (xm-x)>0 then
                                             d := tol1*(xm-x)
                             else
                                             d := -tol1*(xm-x);
               goto l50;
l40:           if x>=xm then
                            e := a-x
               else
                            e := b-x;
               d := c*e;
l50:           if Abs(d)>=tol1 then
                                   u := x+d
               else
                                   u := x+tol1*Abs(d)/d;
               fu := F(u);
               if fu<=fx then
               begin
                    if u>=x then
                            a := x
                    else
                            b := x;
                    v  := w;
                    fv := fw;
                    w  := x;
                    fw := fx;
                    x  := u;
                    fx := fu;
                    Continue;
               end;
               if u<x then
                          a := u
               else
                          b := u;
               if (fu<=fw) or (w=x) then
               begin
                    v  := w;
                    fv := fw;
                    w  := u;
                    fw := fu;
                    Continue;
               end;
               if (fu<=fv) or (v=x) or (v=w) then
               begin
                    v  := u;
                    fv := fu;
               end;
         until 2>3;
{90}     Result := x;
    End;

   function Quanc8(Fun :TFX; a,b,abserr,relerr :Tfloat;
            var errest,flag :Tfloat; var Nofun :integer):Tfloat;

   Label
         l30, l50, l60, l62, l70, l80;
   var
      w0, w1, w2, w3, w4, area, x0, f0, stone, step, cor11, temp :Tfloat;
      qprev, qnow, qdiff, qleft, esterr, tolerr :Tfloat;
      qright : array [1..31] of Tfloat;
      f, x   : array [1..16] of Tfloat;
      fsave, xsave : array [1..8, 1..30] of Tfloat;
      levmin, levmax, levout, nomax, nofin, lev, nim, i, j :integer;

   Begin
{step 1}
         levmin  := 1;
         levmax  := 30;
         levout  := 6;
         nomax   := 5000;
         nofin   := nomax-8*(levmax-levout+Round(IntPower(2,levout+1)));
         w0      := 3956/14175;
         w1      := 23552/14175;
         w2      := -3712/14175;
         w3      := 41984/14175;
         w4      := -18160/14175;
         flag    := 0;
         Result  := 0;
         cor11   := 0;
         errest  := 0;
         area    := 0;
         nofun   := 0;
         if a=b then Exit;
{step 2}
         lev     := 0;
         nim     := 1;
         x0      := a;
         x[16]   := b;
         qprev   := 0;
         f0      := Fun(x0);
         stone   := (b-a)/16;
         x[8]    := (x0+x[16])/2;
         x[4]    := (x0+x[8])/2;
         x[12]    := (x[8]+x[16])/2;
         x[2]    := (x0+x[4])/2;
         x[6]    := (x[4]+x[8])/2;
         x[10]    := (x[8]+x[12])/2;
         x[14]    := (x[12]+x[16])/2;
         for j := 1 to 8 do
                           f[2*j] := Fun(x[2*j]);
         nofun   := 9;
{step 3}
  l30:         x[1]    := (x0+x[2])/2;
               f[1]    := Fun(x[1]);
               for j := 1 to 7 do
               begin
                    x[2*j+1] := (x[2*j]+x[2*j+2])/2;
                    f[2*j+1] := Fun(x[2*j+1]);
               end;
               nofun   := nofun+8;
               step    := (x[16]-x0)/16;
               qleft         := (w0*(f0+f[8])+w1*(f[1]+f[7])+w2*(f[2]+f[6])+
                       w3*(f[3]+f[5])+w4*f[4])*step;
               qright[lev+1] := (w0*(f[8]+f[16])+w1*(f[9]+f[15])+w2*(f[10]+
                       f[14])+w3*(f[11]+f[13])+w4*f[12])*step;
               qnow    := qleft+qright[lev+1];
               qdiff   := qnow-qprev;
               area    := area+qdiff;
{step 4}
               esterr  := Abs(qdiff)/1023;
               tolerr  := Max(abserr,relerr*Abs(area))*(step/stone);
               if lev<levmin then goto l50;
               if lev>=levmax then goto l62;
               if nofun>nofin then goto l60;
               if esterr<=tolerr then goto l70;
{step 5}
  l50:         nim     := 2*nim;
               lev     := lev+1;
               for i := 1 to 8 do
               begin
                    fsave[i,lev] := f[i+8];
                    xsave[i,lev] := x[i+8];
               end;
               qprev    := qleft;
               for i := 1 to 8 do
               begin
                    j         := -i;
                    f[2*j+18] := f[j+9];
                    x[2*j+18] := x[j+9];
               end;
               goto l30;
{step 6}
  l60:         nofin    := 2*nofin;
               levmax   := levout;
               flag     := flag + (b-x0)/(b-a);
               goto l70;
  l62:         flag     := flag+1;
{step 7}
  l70:         Result   := Result+qnow;
               errest   := errest+esterr;
               cor11    := cor11+qdiff/1023;
               while nim<>2*(nim div 2) do
               begin
                    nim := nim div 2;
                    lev := lev-1;
               end;
               nim  := nim+1;
               if lev<=0 then goto l80;
               qprev := qright[lev];
               x0    := x[16];
               f0    := f[16];
               for i := 1 to 8 do
               begin
                    f[2*i] := fsave[i,lev] ;
                    x[2*i] := xsave[i,lev];
               end;
               goto l30;
{step 8}
  l80:   Result   := Result + cor11;
         if errest=0 then Exit;
         repeat
               temp := Abs(Result)+errest;
               if temp<>Abs(Result) then Exit;
               errest := 2*errest;
         until 2>3;
   End;

   function QG8(Fun :TFX; a,b :Tfloat):Tfloat;
{    8-    [-1,1]
        }
   Const
        xi : array [1..4] of Tfloat =
           (0.1834346424956498049,0.5255324099163289858,
              0.7966664774136267396,0.9602898564975362317);
        la : array [1..4] of Tfloat =
           (0.3626837833783619830,0.3137066458778872873,
              0.2223810344533744705,0.1012285362903762592);
   var
      xm, xp, z : Tfloat;
      i         : integer;
   Begin
        z := 0;
        for i := 1 to 4 do
        begin
             xp := 0.5*((a+b)+(b-a)*xi[i]);
             xm := 0.5*((a+b)-(b-a)*xi[i]);
             z  := z + la[i]*(Fun(xp)+Fun(xm));
        end;
        Result := 0.5*(b-a)*z;
   end;

   function QG16(Fun :TFX; a,b :Tfloat):Tfloat;
{    16-    [-1,1]
        }
   Const
        xi : array [1..8] of Tfloat =
    (0.09501250983763744018531933542, 0.2816035507792589132304605015,
    0.4580167776572273863424194430, 0.6178762444026437484466717640,
    0.7554044083550030338951011948, 0.8656312023878317438804678977,
    0.9445750230732325760779884155, 0.9894009349916499325961541735);
        la : array [1..8] of Tfloat =
    (0.1894506104550684962853967231, 0.1826034150449235888667636674,
    0.1691565193950025381893120730, 0.1495959888165767320815018558,
    0.1246289712555338720524768242, 0.09515851168249278480992726493,
    0.06225352393864789286284357374, 0.02715245941175409485177972401);
    var
      xm, xp, z : Tfloat;
      i         : integer;
   Begin
        z := 0;
        for i := 1 to 8 do
        begin
             xp := 0.5*((a+b)+(b-a)*xi[i]);
             xm := 0.5*((a+b)-(b-a)*xi[i]);
             z  := z + la[i]*(Fun(xp)+Fun(xm));
        end;
        Result := 0.5*(b-a)*z;
   end;

   function QG32(Fun :TFX; a,b :Tfloat):Tfloat;
{    32-    [-1,1]
        }
   Const
        xi : array [1..16] of Tfloat =
    (0.04830766568773831623481257044, 0.1444719615827964934851863736,
    0.2392873622521370745446032092, 0.3318686022821276497799168057,
    0.4213512761306353453641194362, 0.5068999089322293900237474744,
    0.5877157572407623290407454764, 0.6630442669302152009751151687,
    0.7321821187402896803874266651, 0.7944837959679424069630972990,
    0.8493676137325699701336930050, 0.8963211557660521239653072437,
    0.9349060759377396891709191348, 0.9647622555875064307738119281,
    0.9856115115452683354001750446, 0.9972638618494815635449811287);
        la : array [1..16] of Tfloat =
    (0.09654008851472780056676482981, 0.09563872007927485941908200200,
    0.09384439908080456563918023413, 0.09117387869576388471286888231,
    0.08765209300440381114277196706, 0.08331192422694675522218578188,
    0.07819389578707030647179685906, 0.07234579410884850622516794425,
    0.06582222277636184683948113219, 0.05868409347853554713302466388,
    0.05099805926237617610909199804, 0.04283589802222668057151000069,
    0.03427386291302143262310147256, 0.02539206530926206035998321099,
    0.01627439473090566720042598262, 0.007018610009470099288196469100);

    var
      xm, xp, z : Tfloat;
      i         : integer;
   Begin
        z := 0;
        for i := 1 to 16 do
        begin
             xp := 0.5*((a+b)+(b-a)*xi[i]);
             xm := 0.5*((a+b)-(b-a)*xi[i]);
             z  := z + la[i]*(Fun(xp)+Fun(xm));
        end;
        Result := 0.5*(b-a)*z;
   end;
   
   function QGL8(Fun :TFX):Tfloat;
{    8-     [0,infinity]
    exp(-x)     }
   Const
        xi : array [1..8] of Tfloat =
           (0.1702796323051009998,0.9037017767993799122,
              2.2510866298661306893,4.2667001702876587937,
              7.0459054023934656973,10.758516010180995224,
              15.740678641278004578,22.863131736889264106);
        la : array [1..8] of Tfloat =
           (0.3691885893416375299,0.41878678081434295607,
              0.1757949866371718058,0.03334349226121565142,
              0.0027945362352256725447,0.000090765087733582130766,
              0.8485746716272531558e-6,0.1048001174871510381e-8);
   var
      z : Tfloat;
      i : integer;
   Begin
        z := 0;
        for i := 1 to 8 do
        begin
             z  := z + la[i]*(Fun(xi[i]));
        end;
        Result := z;
   end;

   function QGH8(Fun :TFX):Tfloat;
  {    8-    
  [-infinity,infinity]
     exp(-x^2)     }
   Const
        xi : array [1..4] of Tfloat =
           (0.3811869902073221169,1.157193712446780195,
              1.981656756695842926,2.930637420257244019);
        la : array [1..4] of Tfloat =
           (0.6611470125582412910,0.2078023258148918796,
              0.01707798300741347546,0.0001996040722113676192);
   var
      z : Tfloat;
      i : integer;
   Begin
        z := 0;
        for i := 1 to 4 do
        begin
             z  := z + la[i]*(Fun(xi[i]) + Fun(-xi[i]));
        end;
        Result := z;
   end;

    function DQG8(Fun:TFXY; a,b:Tfloat; Fc,Fd:TFX):Tfloat;
   Const
        xi : array [1..4] of Tfloat =
           (0.1834346424956498049,0.5255324099163289858,
              0.7966664774136267396,0.9602898564975362317);
        la : array [1..4] of Tfloat =
           (0.3626837833783619830,0.3137066458778872873,
              0.2223810344533744705,0.1012285362903762592);
   var
      xm, xp, cm, cp, dm, dp, ym, yp, zx, zyp, zym : Tfloat;
      i, j                                   : integer;
   Begin
        zx := 0;
        for i := 1 to 4 do
        begin
             xp := 0.5*((a+b)+(b-a)*xi[i]);
             xm := 0.5*((a+b)-(b-a)*xi[i]);
             cp := Fc(xp);
             cm := Fc(xm);
             dp := Fd(xp);
             dm := Fd(xm);
             zyp := 0;
             zym := 0;
             for j := 1 to 4 do
             begin
                  yp := 0.5*((cp+dp)+(dp-cp)*xi[j]);
                  ym := 0.5*((cp+dp)-(dp-cp)*xi[j]);
                  zyp := zyp + la[j]*(Fun(xp,yp)+Fun(xp,ym));
                  yp := 0.5*((cm+dm)+(dm-cm)*xi[j]);
                  ym := 0.5*((cm+dm)-(dm-cm)*xi[j]);
                  zym := zym + la[j]*(Fun(xm,yp)+Fun(xm,ym));
             end;
             zx := zx + la[i]*(0.5*(dp-cp)*zyp+0.5*(dm-cm)*zym);
        end;
        Result := 0.5*(b-a)*zx;
   end;




{     }
   procedure FEHL(F:TPYDY; Neqn :integer; Y:TVarray;
             t,h:Tfloat;YP,F1,F2,F3,F4,F5,S:TVarray);
   var
       ch:Tfloat;
       k :integer;
   Begin
        ch  := h/4;
        for k:=0 to Neqn-1 do
            F5[k] := Y[k]+ch*YP[k];
        F(t+ch,F5,F1);
        ch  := 3*h/32;
        for k:=0 to Neqn-1 do
            F5[k] := Y[k]+ch*(YP[k]+3*F1[k]);
        F(t+3*h/8,F5,F2);
        ch  := h/2197;
        for k:=0 to Neqn-1 do
            F5[k] := Y[k]+ch*(1932*YP[k]+(7296*F2[k]-7200*F1[k]));
        F(t+12*h/13,F5,F3);
        ch  := h/4104;
        for k:=0 to Neqn-1 do
            F5[k] := Y[k]+ch*((8341*YP[k]-845*F3[k])+
            (29440*F2[k]-32832*F1[k]));
        F(t+h,F5,F4);
        ch  := h/20520;
        for k:=0 to Neqn-1 do
            F1[k] := Y[k]+ch*((-6080*YP[k]+(9295*F3[k]-5643*F4[k]))+
            (41040*F1[k]-28352*F2[k]));
        F(t+h/2,F1,F5);
        ch  := h/7618050;
        for k:=0 to Neqn-1 do
            S[k] := Y[k]+ch*((902880*YP[k]+(3855735*F3[k]-
            1371249*F4[k]))+(3953664*F2[k]+277020*F5[k]))
   End;

   procedure RKF45(F:TPYDY; Neqn :integer; Y:TVarray;
             var t:Tfloat; tout:Tfloat; var relerr:Tfloat;
             abserr:Tfloat; var Iflag :integer);
   var
      a, ae, dt, ee, eeoet, esttol, et, hmin, amax, amin, rer, s,
                            scale, tol, toln, ypk :Tfloat;
      k, mflag                                    :integer;
      hfaild, output                              :boolean;

   const
        remin  :Tfloat = 1.0e-12;
        maxnfe :integer  = 3000;

   label
        l10,l20,l30,l40,l50,l60,l80,l90,l100,
        l25,l45,l55,l65,l85,l95,l150,l200,l220,l300;


   Begin
        if Neqn<1 then goto l10;
        if (relerr<0) or (abserr<0) then goto l10;
        mflag := Abs(Iflag);
        if (mflag=0) or (mflag>8) then goto l10;
        if mflag<>1 then goto l20;
        eps:=1;
        while eps+1>1 do
                        eps := 0.5*eps;
        u26 := 26*eps;
        SetLength(YP, Neqn);
        SetLength(F1, Neqn);
        SetLength(F2, Neqn);
        SetLength(F3, Neqn);
        SetLength(F4, Neqn);
        SetLength(F5, Neqn);
        goto l50;
 l10:   iflag:=8;
        Exit;
 l20:   if (t=tout) and (kflag<>3) then goto l10;
        if mflag<>2 then goto l25;
        if (kflag=3) or (init=0) then goto l45;
        if kflag=4 then goto l40;
        if (kflag=5) and (abserr=0) then goto l30;
        if (kflag=6) and (relerr<=savre) and (abserr<=savae) then goto l30;
        goto l50;
 l25:   if iflag=3 then goto l45;
        if iflag=4 then goto l40;
        if (iflag=5) and (abserr>0) then goto l45;
 l30:   Halt;
 l40:   nfe   := 0;
        if mflag=2 then goto l50;
 l45:   iflag := jflag;
        if kflag=3 then mflag := Abs(iflag);
 l50:   jflag := iflag;
        kflag := 0;
        savre := relerr;
        savae := abserr;
        rer   := 2*eps+remin;
        if (relerr>=rer) then goto l55;
        relerr:= rer;
        iflag := 3;
        kflag := 3;
        Exit;
 l55:   dt    := tout-t;
        if mflag=1 then goto l60;
        if init=0 then goto l65;
        goto l80;
 l60:   init  := 0;
        kop   := 0;
        a     := t;
        F(a, Y, YP);
        nfe   := 1;
        if t<>tout then goto l65;
        iflag := 2;
        Exit;
 l65:   init  := 1;
        h     := Abs(dt);
        toln  := 0;
        for k:=0 to Neqn-1 do
        begin
             tol   := relerr*Abs(Y[k])+abserr;
             if tol>0 then
             begin
                  toln  := tol;
                  ypk   := Abs(YP[k]);
                  if (ypk*IntPower(h,5))>tol then h := Power(tol/ypk,0.2);
             end;
        end;
        if toln<=0 then h := 0;
        h     := Max(h, u26*Max(Abs(t),Abs(dt)));
        if iflag>=0 then jflag := 2
                    else jflag := -2;
 l80:   h := h*Abs(dt)/dt;
        if Abs(h)>=2*Abs(dt) then kop := kop+1;
        if kop<> 100 then goto l85;
        kop   := 0;
        iflag := 7;
        Exit;
 l85:   if Abs(dt)>(u26*Abs(t)) then goto l95;
        for k:=0 to Neqn-1 do
            Y[k] := Y[k]+dt*YP[k];
        a     := tout;
        F(a,Y,YP);
        nfe   := nfe+1;
        goto l300;
 l95:   output := false;
        scale  := 2/relerr;
        ae     := scale*abserr;
 l100:  hfaild := false;
        hmin   := u26*Abs(t);
        dt     := tout-t;
        if Abs(dt)>=(2*Abs(h)) then goto l200;
        if Abs(dt)>Abs(h) then goto l150;
        output := true;
        h      := dt;
        goto l200;
 l150:  h      := 0.5*dt;
 l200:  if nfe<= maxnfe then goto l220;
        iflag  := 4;
        kflag  := 4;
        Exit;
 l220:  FEHL(F, Neqn, Y, t, h, YP, F1, F2, F3, F4, F5, F1);
        nfe    := nfe+5;
        eeoet  := 0;
        for k:=0 to Neqn-1 do
        begin
             et := Abs(Y[k])+Abs(F1[k])+ae;
             if et>0 then
              ee:= Abs((-2090*YP[k]+(21970*F3[k]-15048*F4[k]))+
                      (22528*F2[k]-27360*F5[k]))
                     else
             begin
                  iflag  := 5;
                  Exit;
             end;
             eeoet := Max(eeoet, ee/et);
        end;
        esttol  := Abs(h)*eeoet*scale/752400;
        if esttol>1 then
        begin
             hfaild := true;
             output := false;
             s      := 0.1;
             if esttol < 59049 then s:= 0.9/Power(esttol,0.2);
             h      := s*h;
             if Abs(h)>hmin then goto l200;
             iflag  := 6;
             kflag  := 6;
             Exit;
        end;
        t    := t+h;
        for k:=0 to Neqn-1 do
            Y[k] := F1[k];
        a    := t;
        F(a, Y, YP);
        nfe  := nfe+1;
        s    := 5;
        if esttol > 1.889568e-4 then s := 0.9/Power(esttol,0.2);
        if hfaild then s := Min(s, 1);
        h    := Max(s*Abs(h),hmin)*Abs(h)/h;
        if output then goto l300;
        if iflag>0 then goto l100;
        iflag  := -2;
        Exit;
 l300:  t     := tout;
        iflag := 2;
        Exit;
   End;


{  }
   procedure Spline(N:integer; X,Y,B,C,D:TVarray);
   var
      nm1, i :integer;
      t      :Tfloat;
   Begin
        nm1 := N-1;
        if N<2 then Exit;
        if N>=3 then
        begin
             D[0] := X[1]-X[0];
             C[1] := (Y[1]-Y[0])/D[0];
             for i := 1 to NM1-1 do
             begin
                  D[i] := X[i+1]-X[i];
                  B[i] := 2*(D[i-1]+D[i]);
                  C[i+1] := (Y[i+1]-Y[i])/D[i];
                  C[i]   := C[i+1]-C[i];
             end;
             B[0] := -D[0];
             B[N-1] := -D[N-2];
             C[0]   := 0;
             C[N-1] := 0;
             if N<>3 then
             begin
                  C[0] := C[2]/(X[3]-X[1])-C[1]/(X[2]-X[0]);
                  C[N-1] := C[N-2]/(X[N-1]-X[N-3])-C[N-3]/(X[N-2]-X[N-4]);
                  C[0] := C[0]*Sqr(D[0])/(X[3]-X[0]);
                  C[N-1] := -C[N-1]*Sqr(D[N-2])/(X[N-1]-X[N-4]);
             end;
             for i := 1 to N-1 do
             begin
                  t := D[i-1]/B[i-1];
                  B[i] := B[i]-t*D[i-1];
                  C[i] := C[i]-t*C[i-1];
             end;
             C[N-1] := C[N-1]/B[N-1];
             for i := nm1-1 downto 0 do
                  C[i] := (C[i]-D[i]*C[i+1])/B[i];
             B[N-1] := (Y[N-1]-Y[nm1-1])/D[nm1-1]+D[nm1-1]*(C[nm1-1]+2*C[N-1]);
             for i := 0 to nm1-1 do
             begin
                  B[i] := (Y[i+1]-Y[i])/D[i]-D[i]*(C[i+1]+2*C[i]);
                  D[i] := (C[i+1]-C[i])/D[i];
                  C[i] := 3*C[i];
             end;
             C[N-1] := 3*C[N-1];
             D[N-1] := D[N-2];
             Exit;
        end;
{50}    B[0] := (Y[1]-Y[0])/(X[1]-X[0]);
        C[0] := 0;
        D[0] := 0;
        B[1] := B[0];
        C[1] := 0;
        D[1] := 0;
   End;

   function  Seval(N:integer;U:Tfloat; X,Y,B,C,D:TVarray):Tfloat;
   var
      j,k :integer;
      dx    :Tfloat;
   const
        i :integer = 1;
   Begin
        if i>=N then
                    i := 1;
        if (U<X[i-1]) or not (U<=X[i]) then
        begin
             i := 1;
             j := N+1;
             repeat
                   k := (i+j) div 2;
                   if U<X[k-1] then j := k;
                   if U>=X[k-1] then i := k;
             until j<=i+1;
        end;
        dx := U-X[i-1];
        Result := Y[i-1]+dx*(B[i-1]+dx*(C[i-1]+dx*D[i-1]));
   End;

END.
